<template>
  <a-drawer
    :title="title"
    :width="drawerWidth"
    :visible="visible"
    @close="handleCancel"
    :confirmLoading="confirmLoading"
    :maskClosable="maskClosable"
  >
    <a-card :style="getBackground()">
      <template>
        <a-card>
          <div :style="{width: '100%',border: '1px solid #e9e9e9',padding: '10px 16px',background: '#fff',}">
            <a-row :style="{textAlign:'left'}">
              <!-- <a-button
                :style="{marginRight: '8px'}"
                @click="handleSW"
                :disabled=SWbuttonDistable
                type="primary"
              >开工</a-button> -->
              <a-button
                :style="{marginRight: '8px'}"
                @click="handleReport"
                :disabled="buttonDistable"
                type="primary"
              >提交</a-button>
              <!-- <a-button
                :style="{marginRight: '8px'}"
                @click="handleReset"
                :disabled="revocationDistable"
                type="primary"
              >撤销</a-button> -->
            </a-row>
          </div>
          <div :style="{width: '100%',border: '1px solid #e9e9e9',padding: '10px 16px',background: '#fff',}">
            <a-row :gutter="24">
              <a-col :span="4">
                <a-form-item
                  :labelCol="labelCol"
                  :wrapperCol="wrapperCol"
                  label="状态"
                  class="hightColor"
                >
                  <span
                    v-if="this.model != null"
                    class="hightColor"
                  >{{ this.model.status_dictText }}</span>
                  <span
                    v-else
                    class="frozenRowClass"
                  >-</span>
                </a-form-item>
              </a-col>
              <a-col :span="5">
                <a-form-item
                  :labelCol="labelCol"
                  :wrapperCol="wrapperCol"
                  label="检定工单号"
                  class="hightColor"
                >
                  <span
                    v-if="this.model != null"
                    class="hightColor"
                  >{{ this.model.num }}</span>
                  <span
                    v-else
                    class="frozenRowClass"
                  >-</span>
                </a-form-item>
              </a-col>
              <a-col :span="5">
                <a-form-item
                  :labelCol="labelCol"
                  :wrapperCol="wrapperCol"
                  label="设备编号"
                  class="hightColor"
                >
                  <span
                    v-if="this.model != null"
                    class="hightColor"
                  >{{ this.model.equipmentNum }}</span>
                  <span
                    v-else
                    class="frozenRowClass"
                  >-</span>
                </a-form-item>
              </a-col>
              <a-col :span="5">
                <a-form-item
                  :labelCol="labelCol"
                  :wrapperCol="wrapperCol"
                  label="设备名称"
                  class="hightColor"
                >
                  <span v-if="this.model != null">{{ this.model.equipmentName }}</span>
                  <span
                    v-else
                    class="frozenRowClass"
                  >-</span>
                </a-form-item>
              </a-col>
              <a-col :span="5">
                <a-form-item
                  :labelCol="labelCol"
                  :wrapperCol="wrapperCol"
                  label="设备型号"
                  class="hightColor"
                >
                  <span v-if="this.model != null">{{ this.model.equipmentModel }}</span>
                  <span
                    v-else
                    class="frozenRowClass"
                  >-</span>
                </a-form-item>
              </a-col>
            </a-row>
          </div>

          <a-tabs
            type="card"
            defaultActiveKey="1"
          >
            <a-tab-pane
              tab='精度参数'
              key="1"
              class="hightColor"
            >
              <div>
                <a-table
                  ref="table"
                  size="middle"
                  bordered
                  rowKey="id"
                  :columns="columns"
                  :dataSource="dataSource"
                  :loading="loading"
                  @change="handleTableChange"
                  :pagination="ipagination"
                >
                  <!-- :scroll="{ x: 'calc(1200px + 50%)', y: 900 }" -->
                  <template
                    v-for="col in columns"
                    :slot="col.dataIndex"
                    slot-scope='text, record, index'
                  >
                    <div :key="col.dataIndex">
                      <a-input-number
                        :value="text"
                        v-if="col.dataIndex == 'actualValue'"
                        :min="0"
                        :max="20000000"
                        @change="(e)=>handleChange(e, record.key, col, index,record)"
                        style="width: 100%"
                        :disabled="buttonDistable"
                      />
                    </div>
                  </template>
                </a-table>
              </div>
            </a-tab-pane>

            <a-tab-pane
              tab='鉴定报告'
              key="2"
            >
              <div
                class="table-operator"
                style="margin:-16px"
              >
                <equipment-calibration-order-report-drawer-list
                  :buttonDistable='buttonDistable'
                  :calibrationOrderId='calibrationOrderId'
                />
              </div>
            </a-tab-pane>
          </a-tabs>
        </a-card>
      </template>
    </a-card>

    <div :style="{width: '100%',border: '1px solid #e9e9e9',padding: '10px 16px',background: '#fff',}">
      <a-row :style="{textAlign:'right'}">
        <a-button
          :style="{marginRight: '8px'}"
          @click="handleCancel"
        >
          取消
        </a-button>
        <a-button
          :style="{marginRight: '8px'}"
          @click="handleTS"
          :disabled="buttonDistable"
          type="primary"
          v-if="false"
        >暂存</a-button>
        <a-button
          @click="handleOk"
          :disabled="buttonDistable"
          type="primary"
        >保存</a-button>
      </a-row>
    </div>
  </a-drawer>
</template>

<script>
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import { requestPut, getAction, downFile } from '@/api/manage'
import Tooltip from 'ant-design-vue/es/tooltip'

import { preview } from 'vue-photo-preview'
import { ACCESS_TOKEN } from '@/store/mutation-types'
import Vue from 'vue'
import PdfView from '@views/common/PdfView'
import { getFileAccessHttpUrl } from '@/api/manage';
import EquipmentCalibrationOrderReportDrawerList from './EquipmentCalibrationOrderReportDrawerList'


export default {
  name: 'EquipmentCalibrationOrderExeDrawer',
  mixins: [JeecgListMixin],
  components: {
    PdfView,
    preview,
    Tooltip,
    EquipmentCalibrationOrderReportDrawerList,
  },
  data() {
    return {
      title: "检定工单执行",
      visible: false,
      maskClosable: true,
      confirmLoading: false,
      drawerWidth: "100%",
      buttonDistable: false,
      SWbuttonDistable: false,
      revocationDistable: false,
      // currentNodeSelect: '',
      calibrationOrderId: '-1',
      dataSource: [],
      model: {},
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
      },
      columns: [
          {
            title: '#',
            dataIndex:'sort',
            width:100,
            align:"center",
          },
          {
            title:'检验项目名称',
            align:"center",
            dataIndex: 'name',
            width:300
          },
          {
            title:'位置',
            align:"center",
            dataIndex: 'precisionParametersUda1',
            width:300
          },
          {
            title:'允差（mm）',
            align:"center",
            dataIndex: 'tolerance',
            width:300
          },
          {
            title:'实测值',
            align:"center",
            dataIndex: 'actualValue',
            scopedSlots: { customRender: 'actualValue' },
            width:300
          },
      ],
      url: {
        list: "/eam/calibrationOrder/listByMainId",
        report: "/eam/calibrationOrder/report",
        save: "/eam/calibrationOrderDetail/save",
      },
    }
  },
  mounted() {
    this.$bus.$on('closeDrawer', (data) => {
      this.visible = false;
    })
  },

  methods: {

    handleShow(record) {
      this.model = Object.assign({}, record);
      this.calibrationOrderId = record.id
      this.dataSource = []
      this.visible = true;
      this.queryParam.calibrationOrderId = record.id
      this.loadData1(1)
    },

    loadData1(arg) {
      if (!this.url.list) {
        this.$message.error("请设置url.list属性!")
        return
      }
      //加载数据 若传入参数1则加载第一页的内容
      if (arg === 1) {
        this.ipagination.current = 1;
      }
      var params = this.getQueryParams();//查询条件
      this.loading = true;
      getAction(this.url.list, params).then((res) => {
        if (res.success) {
          this.dataSource = res.result.records || res.result;
          if (res.result.total) {
            this.ipagination.total = res.result.total;
          } else {
            this.ipagination.total = 0;
          }
        } else {
          this.$message.warning(res.message)
        }
      }).finally(() => {
        this.loading = false
      })
    },

    loadData() {
    },
    getBackground() {
      return "background-color:rgba(127, 127, 127,0.08)";
    },
    handleCancel() {
      this.$emit('ok');
      this.alterFlag = new Date();
      this.close()
    },
    close() {
      this.visible = false;
    },
    //暂存
    // handleTS() {

    // },
    //开工
    // handleSW() {
    //   const that = this;
    //   that.confirmLoading = true;
    //   this.$confirm({
    //     title: '保养工单开工',
    //     content: '提示：开工后无法撤回，请谨慎操作！',
    //     okText: '确认',
    //     cancelText: '取消',
    //     onOk() {
    //       requestPut(that.url.editStatus, { id: that.model.id, status: '4' }).then((res) => {
    //         if (res.success) {
    //           that.model.status = '4'
    //           that.$message.success("工单开工成功！")
    //           that.buttonDistable = false
    //           that.revocationDistable = true
    //           that.SWbuttonDistable = true
    //         } else {
    //           that.$message.warning("工单开工失败！")
    //         }
    //       }).finally(() => {
    //         that.confirmLoading = false;
    //         // that.close();
    //       })
    //     },
    //   })
    // },
    //报工
    handleReport() {
      const that = this;
      that.confirmLoading = true;
      this.$confirm({
        title: '检定工单提交完工',
        content: '提示：报工后工单完工，请谨慎操作！',
        okText: '确认',
        cancelText: '取消',
        onOk() {
          requestPut(that.url.report, { id: that.model.id, status: '4' }).then((res) => {
            if (res.success) {
              that.model.status = '5'
              that.$message.success(res.message)
              that.buttonDistable = false
              that.revocationDistable = true
              that.SWbuttonDistable = true
              that.$emit('ok');
              that.alterFlag = new Date();
              that.close();
            } else {
              that.$message.warning(res.message)
            }
          }).finally(() => {
            that.confirmLoading = false;
            // 
          })
        },
      })
    },
    //撤销
    // handleReset() {
    //   const that = this;
    //   that.confirmLoading = true;
    //   this.$confirm({
    //     title: '完工撤销',
    //     content: '提示：完工撤销后可继续报工操作！',
    //     okText: '确认',
    //     cancelText: '取消',
    //     onOk() {
    //       requestPut(that.url.revocation, { id: that.model.id, status: '4' }).then((res) => {
    //         if (res.success) {
    //           that.model.status = '4'
    //           that.$message.success(res.message)
    //           that.buttonDistable = false
    //           that.revocationDistable = true
    //           that.SWbuttonDistable = true
    //         } else {
    //           that.$message.warning(res.message)
    //         }
    //       }).finally(() => {
    //         that.confirmLoading = false;
    //         // that.close();
    //       })
    //     },
    //   })
    // },

    handleChange(value, key, column, index) {
      let that = this;
      const temp = [...that.dataSource];
      const target = temp.filter(item => key === item.key)[index];
      if (target) {
        if (column.dataIndex == 'calibrationItemResult') {
          target[column.dataIndex] = value;
          let maxValue = target.upperLimit
          let minValue = target.lowerLimit
          if (value > minValue && value < maxValue) {
            target['judgmentResult'] = "pass";
            // target['judgmentResultName'] = "正产";
          } else {
            target['judgmentResult'] = "fail";
            // target['judgmentResultName'] = "异常";
          }
          if (value == null || value == "") {
            target['judgmentResult'] = "";
            // target['judgmentResultName'] = "";
          }

        }
        if(column.dataIndex == 'actualValue'){
          target[column.dataIndex] = value;
        }
        //显示带过来的数据
        that.dataSource = temp;
      }
    },
    //保存
    handleOk() {
      const that = this;
      that.confirmLoading = true;
      let formData = Object.assign(this.model);
      for (let i = 0; i < that.dataSource.length; i++) {
        let o = this.dataSource[i]
        if (o.actualValue == null || o.actualValue == '') {
          that.$message.warning('请输入序号为'+o.sort+'检验项的实测值')
          that.confirmLoading = false;
          return
        }
      }
      formData.calibrationOrderDetails = that.dataSource
      requestPut(this.url.save, formData).then((res) => {
        if (res.success) {
          that.$message.success("保存成功!");
          that.$emit('ok');
          that.alterFlag = new Date();
          that.loadData1()
        } else {
          that.$message.warning("保存失败!");
        }
      }).finally(() => {
        that.confirmLoading = false;
        // that.close();
      })
    },

  },

}
</script>

<style scoped>
@import '~@assets/less/common.less';
.hightColor {
  height: 10%;
  font-weight: bold;
  font-size: 20px;
  color: #1b1e1e;
}
.frozenRowClass {
  color: #c9c9c9;
}
.fontweight {
  font-weight: bold;
}
.hight {
  color: #f5222d;
}
/deep/ .red {
  color: red;
}
</style>